import { select, range } from 'd3';

const width = 960;
const height = 500;

const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

svg
  .selectAll('rect.horizontal')
  .data(range(100))
  .join('rect')
	.attr('class', 'horizontal')
  .attr('y', (d) => d * 20)
  .attr('width', width)
  .attr('height', 10)
  .attr('mask', 'url(#circle-mask)');

svg
  .selectAll('rect.vertical')
  .data(range(100))
  .join('rect')
	.attr('class', 'vertical')
  .attr('x', (d) => d * 20)
  .attr('height', height)
  .attr('width', 10)
  .attr('mask', 'url(#circle-mask-2)');

const mask = svg
  .append('mask')
  .attr('id', 'circle-mask');

mask
	.append('rect')
  .attr('width', width)
  .attr('height', height)
  .attr('fill', 'black');

mask
	.append('circle')
  .attr('cx', width/2)
  .attr('cy', height/2)
	.attr('r', 200)
  .attr('fill', 'white');

const mask2 = svg
  .append('mask')
  .attr('id', 'circle-mask-2');

mask2
	.append('rect')
  .attr('width', width)
  .attr('height', height)
  .attr('fill', 'white');

mask2
	.append('circle')
  .attr('cx', width/2)
  .attr('cy', height/2)
	.attr('r', 200)
  .attr('fill', 'black');